//
//  CFGSocket.m
//  FGHelloDevice
//
//  Created by Francesco on 5/4/06.
//  Copyright 2006 Softech di Germinara Francesco. All rights reserved.
//

#import "CFGSocket.h"

#import "netDB.h"

@implementation CFGSocket

- (id) init {
	self = [super init];
	if (self != nil) {
     int i=0;
	 for(i=0;i<4;i++)
      StatoIO.IOStatus[i]=0x00;
  
      m_OpenConnection=FALSE;	
	  idFile=-1;
  	}
	return self;
}


- (void) dealloc {
	[self CloseConnection];
	[super dealloc];
}

//Close the connection
- (void) CloseConnection{
 if(idFile != -1)
  close(idFile);
 m_OpenConnection=FALSE;
 idFile=-1;
}

//Crea il Socket per la comunicazione
- (BOOL) CreateSocket:(NSString*) ipAddress withPort:(unsigned int) port{
 BOOL sts=FALSE;  
 int result=0;
 if(idFile != -1){ //Connection already present
  sts=TRUE;
 }else{
 idFile = socket(AF_INET,SOCK_STREAM,0);
 [self initDevice:ipAddress withPort:port]; //inizializzo le strutture per la comunicazzione con il device
 result=connect(idFile,(struct sockaddr *) &clientAddr,sizeof(clientAddr));
 if(result != -1)
  m_OpenConnection=TRUE;
 } 
 return sts;
}

-(void)initDevice:(NSString*) ipAddress withPort:(unsigned int) nPort{

  ipAddr=0 ;
  struct hostent *hostinfo;
  hostinfo=gethostbyname([ipAddress UTF8String]);
  
  memcpy(&ipAddr, hostinfo->h_addr_list[0], hostinfo->h_length);	
	
	// Clear IP address fields
	memset( (char*) &addr, 0, sizeof( addr ) );
	memset( (char*) &clientAddr, 0, sizeof( clientAddr ) ); 

	// Set my IP address : TCP port 
	addr.sin_family = AF_INET;
	addr.sin_port = htons(nPort);	
	addr.sin_addr.s_addr = INADDR_ANY;

	clientAddr.sin_family = AF_INET;
	clientAddr.sin_port = htons(nPort);
	clientAddr.sin_addr.s_addr = htonl(ipAddr);
	
	clientLenght = sizeof(clientAddr);
}

//Leggo stato di Input e Output
-(BOOL) ReadStatus{
   char commandBuf, *responseBuf=NULL;
   int  commandLen;
   int nLenReceived=0;
   BOOL sts=FALSE;   
   int i=0; 
   
   //Command buffer
   commandBuf=IOGet;
   commandLen=1;
   
   //Response buffer
   responseBuf=(char*) calloc(0x10,1);
   memset(responseBuf,'A',0x10);
   
   if(write(idFile,&commandBuf,commandLen)!=-1){ //Ok,
	nLenReceived=read(idFile,responseBuf,0x10);
	 if(nLenReceived==4){
      for(i=0; i<4; i++)
       StatoIO.IOStatus[i]=responseBuf[i];
      sts=TRUE;  
	 }
   }
   free(responseBuf);
   
	  
   // Debug only 
   NSString *msg;
   msg=[[NSString alloc] initWithFormat:@"Valori letti: Input: [%x] [%x] OutPut: [%x] [%x]",StatoIO.IOStatus[0],StatoIO.IOStatus[1],StatoIO.IOStatus[2],StatoIO.IOStatus[3]];
   NSLog(msg);
   [msg release];
  
    return sts;
}

//Imposto il valore del bit specificato
-(void)SetBit:(int) nBit withStatus:(BOOL) sts{
 if(nBit<0)
  return; //NOP
 
 dato.byte=word.bytes.msb;
 switch(nBit){
  case 0: dato.bit.b0=sts; break;
  case 1: dato.bit.b1=sts; break;
  case 2: dato.bit.b2=sts; break;
  case 3: dato.bit.b3=sts; break;
  case 4: dato.bit.b4=sts; break;
  case 5: dato.bit.b5=sts; break;
  case 6: dato.bit.b6=sts; break;
  case 7: dato.bit.b7=sts; break;
 }
 word.bytes.msb=dato.byte;

 dato.byte=word.bytes.lsb;
 switch(nBit){
  case  8: dato.bit.b0=sts; break;
  case  9: dato.bit.b1=sts; break;
  case 10: dato.bit.b2=sts; break;
  case 11: dato.bit.b3=sts; break;
  case 12: dato.bit.b4=sts; break;
  case 13: dato.bit.b5=sts; break;
  case 14: dato.bit.b6=sts; break;
  case 15: dato.bit.b7=sts; break;
 }
 word.bytes.lsb=dato.byte;
 
 StatoIO.porta.output.dw=word.dw;
}

//Imposto il valore del bit specificato
-(void)SetBitAsString:(NSString*) strNBit withStatus:(BOOL) sts{
 int nBit=0;
 if([strNBit isEqualToString:@""] || [strNBit isEqualToString:@"  "])
  return; //NOP
 nBit=[strNBit intValue];
 [self SetBit:nBit withStatus:sts];
}


//Restituisce il valore del bit specificato
-(BOOL) GetBit:(int) nBit{
 if(nBit<8){
  dato.byte=word.bytes.msb;
  switch(nBit){
   case 0: return dato.bit.b0;
   case 1: return dato.bit.b1;
   case 2: return dato.bit.b2;
   case 3: return dato.bit.b3;
   case 4: return dato.bit.b4;
   case 5: return dato.bit.b5;
   case 6: return dato.bit.b6;
   case 7: return dato.bit.b7;
   default: return FALSE;
  }
 }else{
  dato.byte=word.bytes.lsb;
  switch(nBit){
   case  8: return dato.bit.b0; 
   case  9: return dato.bit.b1;
   case 10: return dato.bit.b2;
   case 11: return dato.bit.b3;
   case 12: return dato.bit.b4;
   case 13: return dato.bit.b5;
   case 14: return dato.bit.b6;
   case 15: return dato.bit.b7;
   default: return FALSE;
  }
 }
}

//Restituisce il valore del bit specificato
-(BOOL) GetBitAsString:(NSString*) strNBit{
 int nBit=0;
 nBit=[strNBit intValue];
 return [self GetBit:nBit];
}

-(NSString*) ShowInputStatus{
 NSMutableString *msgStsInp;
 msgStsInp=[NSMutableString stringWithString:@"Stato Input: "];
 BOOL sts=0;
 int i=0;
 word.dw = StatoIO.porta.input.dw;

 for(i=0; i< 16; i++){
  sts=[self GetBit:i];
  [msgStsInp appendFormat:@"b%02d[%s] ",i, sts==0 ? "Off" : "On"];
 }
 return msgStsInp;
}

-(NSString*) ShowOutputStatus{
 NSMutableString *msgStsOut;
 msgStsOut=[NSMutableString stringWithString:@"Stato Output: "];
 BOOL sts=0;
 int i=0;
 word.dw = StatoIO.porta.output.dw;

 for(i=0; i< 16; i++){
  sts=[self GetBit:i];
  [msgStsOut appendFormat:@"b%02d[%s] ",i, sts==0 ? "Off" : "On"];
 }
 return msgStsOut;
}


//Imposto stato Output
-(BOOL) SetOutput{
   char commandBuf[3];
   int  commandLen;
   
   commandBuf[0]=IOSet;
   commandBuf[1]=(unsigned char)StatoIO.porta.output.bytes.lsb;
   commandBuf[2]=(unsigned char)StatoIO.porta.output.bytes.msb;
   
   commandLen=3;
   BOOL sts=FALSE;   
   if(write(idFile,commandBuf,commandLen)!=-1){ //Ok,
    sts=true;
   }
   
   //sleep(50);
   return sts;
}


-(BOOL) GetInputStatus:(int) nBit useInvertedState:(BOOL) bInverted{
 BOOL sts=0;
 word.dw = StatoIO.porta.input.dw;
 sts=[self GetBit:nBit];
 if(bInverted)
  sts=!sts;
 return sts;
}

-(BOOL)GetOutputStatus:(int) nBit{
 BOOL sts=0;
 word.dw = StatoIO.porta.output.dw;
 sts=[self GetBit:nBit];
 return sts;
}

-(void) SetOutputStatus:(int) nBit withStatus:(BOOL) status{
 word.dw = StatoIO.porta.output.dw;
 [self SetBit:nBit withStatus:status];
 StatoIO.porta.output.dw=word.dw;
}

-(void) SetAllOutputStatus:(BOOL) status{
 int i=0;
 for(i=0;i<16;i++)
  [self SetOutputStatus:i withStatus:status];
 [self SetOutput];  
}




@end
