//
//  CFGSocket.h
//
//  FGHelloDevice
//
//  Created by Francesco on 5/4/06.
//  Copyright 2006 Softech di Germinara Francesco. All rights reserved.
//
//  www.germinara.it - info@germinara.it
//

#import <Cocoa/Cocoa.h>

#import "CFGSocket.h"

@interface theController : NSObject
{
  CFGSocket *aFGSocket; //the classe for HD1100 management

  NSTimer *aReadTimer; //the timer for read inputs
  
  IBOutlet NSTextField *theIPAddress; //The preconfigured IP address
  IBOutlet NSTextField *thePort; //the communication port of the HD1100 device
  
  IBOutlet NSMatrix *theInputs;  //The Inputs check buttons
  IBOutlet NSMatrix *theOutpus;  //The Output check buttons
  IBOutlet NSButton *chkManualRead; //Activate or no the timer for read inputs
  IBOutlet NSButton *btnReadInputs; //Button for manually read inputs status 
  IBOutlet NSButton *btnWriteOutputs; //Button for commit the Output status
  
}
-(void) startReadTimer:(NSTimeInterval)interval; //Internal use, for starting the timer
-(void) stopReadTimer; //Internal use, for stop timer

- (IBAction)btnReadInputs:(id)sender;    //Read Inputs Status from HD1100 device
- (IBAction)btnWriteOutputs:(id)sender;  //Write Outputs Status to HD1100 device
- (IBAction)btnChkManualRead:(id)sender; //Enable the auto read inputs status with timer

-(void)  setInputsStatus;   //Update UI for Inputs status
 -(void) setOutputsStatus;  //Update UI for Outputs status

@end
